Qt Reference Documentation

# QAbstractUriResolver Class Reference

The QAbstractUriResolver class is a callback interface for resolving Uniform Resource Identifiers. More...

     #include <QAbstractUriResolver>

Inherits: QObject.

Note: All functions in this class are reentrant.

This class was introduced in Qt 4.4.

- List of all members, including inherited members

## Public Functions

| QAbstractUriResolver ( QObject * parent = 0 )
virtual | ~QAbstractUriResolver ()
virtual QUrl | resolve ( const QUrl & relative, const QUrl & baseURI ) const = 0

- 29 public functions inherited from QObject

### Additional Inherited Members

- 1 property inherited from QObject
- 1 public slot inherited from QObject
- 1 signal inherited from QObject
- 7 static public members inherited from QObject
- 8 protected functions inherited from QObject

## Detailed Description

The QAbstractUriResolver class is a callback interface for resolving Uniform Resource Identifiers.

A Uniform Resource Identifier (URI) is a string that uniquely identifies a resource. URIs are versatile global identifiers. It is often useful to transform a URI that identifies something logical into a URI that locates something physical (a URL), or to simply map a URI to a different URI. QAbstractUriResolver::resolve() provides this functionality.

For example, one could write a QAbstractUriResolver subclass that rewrites library ISBN number URIs as book title URLs, e.g., urn:isbn:0-345-33973-8 would be rewritten as file:///books/returnOfTheKing.doc. Or a QAbstractUriResolver subclass could be written for a web browser to let the web browser protect the user's private files by mapping incoming requests for them to null URIs.

See also http://en.wikipedia.org/wiki/Uniform_Resource_Identifier.

## Member Function Documentation

### QAbstractUriResolver::QAbstractUriResolver ( QObject * parent = 0 )

Constructs a QAbstractUriResolver with the specified parent.

### QAbstractUriResolver::~QAbstractUriResolver ()`[virtual]`

Destructor.

### QUrl QAbstractUriResolver::resolve ( const QUrl & relative, const QUrl & baseURI ) const`[pure virtual]`

Returns the relative URI resolved using the baseURI.

The caller guarantees that both relative and baseURI are valid, and that baseURI is absolute. relative can be relative, absolute, or empty.

The returned QUrl can be a default constructed QUrl. If it is not a default constructed QUrl, it will be absolute and valid. If a default constructed QUrl is returned, it means the relative URI was not accepted to be resolved.

If the reimplemented resolve() function decides it has nothing to do about resolving the relative URI, it should simply return the relative URI resolved against the baseURI, i.e.:

     return baseURI.resolved(relative);

See also QUrl::isRelative() and QUrl::isValid().